/*
**	dbadmin.h	- 
**
**
** Copyright (c) 1996 James E. Harrell, Jr.
**
** This software is provided "as is" without any expressed or implied warranty.
**
**  Notes: 1) Set the RELPATH variable below to the relative path of the dbadmin
**            CGI directory as understood by the httpd server.
**         2) If you have trouble with queries being truncated, redefine the
**            MAX_TEXT_QUERY_LEN variable below. It will allow all queries
**            to be longer. This constant affects all queries generated by
**            the program EXCEPT for the "enter manual query" field. That
**            query is dynamically allocated, and may be of any length.
**         3) MAX_FIELDNAME_LEN seems to be 19 for msql. Two behaviors may be
**            specified by changing this value withing dbadmin. To truncate
**            fieldnames that are too long, set MAX_FIELDNAME_LEN=20. To
**            give an error if a field name is too long set = 21 or greater.
**         4) The MAX_FIELDS definition may NOT be increased without some
**            significant (but simple) code changes. See the function
**            getFields in dbadmin.c STATE = 7. Necessary changes should be
**            self-evident. I picked 25 as a practical limit.
**             HOWEVER, the MAX_FIELDS constant ONLY AFFECTS ADDING NEW TABLES
**            into your database, using the forms interface. You may add more
**            fields for a table by entering the query by hand with this or
**            any other tool that allows you to.
**
*/
#define RELPATH "/cgi-bin/dbadmin"
#define VERSION "v1.0.1"

#define DEBUGx
 
#define MAX_FIELDS 25
#define MAX_FIELDNAME_LEN 20          /* SEE NOTE 3 ABOVE */
#define MAX_TEXTQUERY_LEN 5000
#define ADD_DB 1
#define REM_DB 2

/* DATABASE LIST VERSIONS */
#define NORMAL 0
#define RADIO_LIST 1
